Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports System.Runtime.CompilerServices

Namespace OnDemandAssemblyDemo
	Partial Public Class Page
		Inherits UserControl
		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub CreateCalendarButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Dim wc As New WebClient()
			AddHandler wc.OpenReadCompleted, AddressOf wc_OpenReadCompleted
			wc.OpenReadAsync(New Uri("System.Windows.Controls.dll", UriKind.Relative))
		End Sub

		Private Sub wc_OpenReadCompleted(ByVal sender As Object, ByVal e As OpenReadCompletedEventArgs)
			If e.Error Is Nothing Then
				' Load the downloaded assembly
				Dim part As New AssemblyPart()
				part.Load(e.Result)

				' Create a Calendar control
				CreateCalendar()
			End If
		End Sub

		<MethodImpl(MethodImplOptions.NoInlining)> _
		Private Sub CreateCalendar()
			Dim cal As New Calendar()
			cal.Width = 300.0
			cal.Height = 200.0
			AddHandler cal.SelectedDatesChanged, AddressOf cal_SelectedDatesChanged
			LayoutRoot.Children.RemoveAt(0)
			LayoutRoot.Children.Add(cal)
		End Sub

		Private Sub cal_SelectedDatesChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
		End Sub
	End Class
End Namespace
